package cn.estsh.i3plus.pojo.andon.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : ANDON_呼叫原因
 * @Reference :
 * @Author : hansen.ke
 * @CreateDate : 2019-05-13 9:50
 * @Modify:
 **/
@Data
@Entity
@Table(name="ANDON_ALARM_CAUSE")
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api("ANDON_呼叫原因")
public class AndonAlarmCause extends BaseBean {

    @Column(name = "AC_CODE")
    @ApiParam(value = "呼叫原因代码")
    private String acCode;

    @Column(name = "AC_NAME")
    @ApiParam(value = "呼叫原因描述")
    private String acName;

    @Column(name = "PARENT_AC_CODE")
    @ApiParam(value = "父阶原因代码")
    private String parentAcCode;

    @Column(name = "ALARM_CODE")
    @ApiParam(value = "安灯类型")
    private String alarmCode;
}
