package cn.estsh.i3plus.pojo.andon.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : ANDON_呼叫通知配置
 * @Reference :
 * @Author : hansen.ke
 * @CreateDate : 2019-05-13 9:53
 * @Modify:
 **/
@Data
@Entity
@Table(name="ANDON_ALARM_RESPONSE_CFG")
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api("ANDON_呼叫通知配置")
public class AndonAlarmResponseCfg extends BaseBean {

    @Column(name = "ALARM_CODE")
    @ApiParam(value = "安灯类型代码")
    private String alarmCode;

    @Column(name = "ANDON_STATUS")
    @ApiParam(value = "安灯状态")
    private String andonStatus;

    @Column(name = "RP_WHERE")
    @ApiParam(value = "通知条件时长")
    private String rpWhere;

    @Column(name = "RP_CODE")
    @ApiParam(value = "通知方式代码")
    private String rpCode;

    @Column(name = "RP_OBJECT_CODE")
    @ApiParam(value = "通知对象代码")
    private String rpObjectCode;

    @Column(name = "RP_LEVEL")
    @ApiParam(value = "通知级别")
    private String rpLevel;
}
