package cn.estsh.i3plus.pojo.form.bean;

import cn.estsh.i3plus.pojo.base.annotation.AnnoOutputColumn;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * @Description : 数据对象
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2019-02-27 10:53
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="bf_data_object")
@Api(value="数据对象",description = "原数据对象，最原始数据")
public class BfDataObject extends BaseBean {

    @Column(name="OBJECT_NAME")
    @ApiParam(value ="数据名称")
    private String objectName;

    @Column(name="OBJECT_CLASS_NAME")
    @ApiParam(value ="类名称")
    private String objectClassName;

    @Column(name="OBJECT_TABLE_NAME")
    @ApiParam(value ="数据表名")
    private String objectTableName;

    @Column(name="OBJECT_CONTENT",columnDefinition="TEXT")
    @ApiParam(value ="数据内容")
    private String objectContent;

    @Column(name="OBJECT_STATUS")
    @ApiParam(value ="表状态(是否同步)")
    private Integer objectStatus;

    @Column(name="OBJECT_TYPE")
    @ApiParam(value ="数据类型")
    private Integer objectType;

    @Column(name="OBJECT_COLUMN_NUM")
    @ApiParam(value ="数据列名数量")
    private Integer objectColumnNum;

    @Column(name="OBJECT_DESCRIPTION")
    @ApiParam(value ="描述")
    private String objectDescription;

    @Transient
    @ApiParam(value = "数据对象属性")
    @AnnoOutputColumn(hidden = true)
    private List<BfDataObjectProperty> propertyList;

    @Transient
    @ApiParam(value = "元素对象虚拟属性")
    @AnnoOutputColumn(hidden = true)
    List<BfElementPropertyVirtual> virtualList;

}
