package cn.estsh.i3plus.pojo.mes.bean;


import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * @Description :工序物料清单
 * @Reference :
 * @Author : jack.jia
 * @CreateDate : 2019-04-02
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="MES_PROCESS_BOM")
@Api("工序物料清单")
public class MesProcessBom extends BaseBean {
    @Column(name="PART_NO")
    @ApiParam("零件号")
    private String partNo;

    @Column(name="PROCESS_CODE")
    @ApiParam("工序代码")
    private String processCode;

    @Column(name="ITEM_PART_NO")
    @ApiParam("子零件")
    private String itemPartNo;

    @Column(name = "QTY")
    @ColumnDefault("0")
    @ApiParam(value = "子零件数量", example = "0")
    private Double qty;

    @Column(name = "IS_REPEAT")
    @ApiParam(value = "是否可重复")
    private Integer isRepeat;

    @Column(name = "IS_CHECK")
    @ApiParam(value = "是否检查")
    private Integer isCheck;

    public double getQtyVal() {
        return this.qty == null ? 0.0d : this.qty;
    }

    public int getIsRepeatVal() {
        return  this.isRepeat == null ? 0 : this.isRepeat;
    }

    public int getIsCheckVal() {
        return this.isCheck == null ? 0 : this.isCheck;
    }
}
