package cn.estsh.i3plus.pojo.platform.sqlpack;

import cn.estsh.i3plus.pojo.base.tool.BsonPackTool;
import cn.estsh.i3plus.pojo.platform.platbean.*;
import com.mongodb.BasicDBObject;
import org.bson.conversions.Bson;

/**
 * @Description : Bson对象封装
 * @Reference :
 * @Author : siliter
 * @CreateDate : 2019-04-11 13:15
 * @Modify:
 **/
public class WmsBsonPack {

    /**
     * 作业日志复杂查询
     *
     * @param actionLog
     * @return
     */
    public static Bson packBsonByActionLog(WmsActionLog actionLog) {
        Bson bson = new BasicDBObject();
        bson = BsonPackTool.timeBuilder(actionLog.getCreateDatetime(), "createDatetime", bson, false, false);
        bson = BsonPackTool.getStringEqualPack(actionLog.getOrderNo(), "orderNo", bson);
        bson = BsonPackTool.getStringEqualPack(actionLog.getTransTypeCode(), "transTypeCode", bson);
        bson = BsonPackTool.getStringEqualPack(actionLog.getFixId(), "fixId", bson);
        bson = BsonPackTool.getNumEqualPack(actionLog.getAgId(), "agId", bson);
        bson = BsonPackTool.getNumEqualPack(actionLog.getActionStatus(), "actionStatus", bson);
        bson = BsonPackTool.getStringEqualPack(actionLog.getAgNameC(), "agNameC", bson);
        bson = BsonPackTool.getStringEqualPack(actionLog.getOrganizeCode(), "organizeCode", bson);
        bson = BsonPackTool.getNumEqualPack(actionLog.getIsValid(), "isValid", bson);
        bson = BsonPackTool.getNumEqualPack(actionLog.getIsDeleted(), "isDeleted", bson);
        return bson;
    }

    /**
     * 作业日志明细复杂查询
     *
     * @param actionLogDetails
     * @return
     */
    public static Bson packBsonByActionLogDetails(WmsActionLogDetails actionLogDetails) {
        Bson bson = new BasicDBObject();
        bson = BsonPackTool.getNumEqualPack(actionLogDetails.getAlId(), "alId", bson);
        bson = BsonPackTool.getStringEqualPack(actionLogDetails.getOrganizeCode(), "organizeCode", bson);
        bson = BsonPackTool.getNumEqualPack(actionLogDetails.getValueType(), "valueType", bson);
        bson = BsonPackTool.getNumEqualPack(actionLogDetails.getSeq(), "seq", bson);
        bson = BsonPackTool.getNumEqualPack(actionLogDetails.getIsValid(), "isValid", bson);
        bson = BsonPackTool.getNumEqualPack(actionLogDetails.getIsDeleted(), "isDeleted", bson);
        return bson;
    }

    /**
     * 调用组件日志复杂查询
     *
     * @param actionLogData
     * @return
     */
    public static Bson packBsonByActionLogData(WmsActionLogData actionLogData) {
        Bson bson = new BasicDBObject();
        bson = BsonPackTool.getNumEqualPack(actionLogData.getAldId(), "aldId", bson);
        bson = BsonPackTool.getStringEqualPack(actionLogData.getOrganizeCode(), "organizeCode", bson);
        bson = BsonPackTool.getNumEqualPack(actionLogData.getIsValid(), "isValid", bson);
        bson = BsonPackTool.getNumEqualPack(actionLogData.getIsDeleted(), "isDeleted", bson);
        return bson;
    }
}
