package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 库位物料表
 * @Reference :
 * @Author : jimmy.zeng
 * @CreateDate : 2018-11-07 10:51
 * @Modify:
 **/
@Data
@Entity
@Table(name = "WMS_LOCATE_PART")
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api(value = "库位物料表", description = "库位物料表")
public class WmsLocatePart extends BaseBean {

    @Column(name = "LOCATE_NO")
    @ApiParam(value = "库位代码")
    private String locateNo;

    @Column(name = "PART_NO")
    @ApiParam(value = "物料编码")
    private String partNo;

    @Column(name = "PART_NAME_RDD")
    @ApiParam(value = "物料名称")
    private String partNameRdd;

    @Column(name = "PULL_QTY")
    @ApiParam(value = "拉动数量", example = "0")
    private Double pullQty;

    @Column(name = "MAX")
    @ApiParam(value = "最大值", example = "0")
    private Double max;

    @Column(name = "MIN")
    @ApiParam(value = "最小值", example = "0")
    private Double min;

    @Column(name = "IS_GENERATE_PICKLIST")
    @ApiParam(value = "是否生成领料单", example = "2")
    private Integer isGeneratePicklist;

    public Double getMin() {
        return this.min == null ? 0 : this.min;
    }

    public Integer getIsGeneratePicklist() {
        return this.isGeneratePicklist == null ? 0 : this.isGeneratePicklist;
    }
}
